"use strict";
///<reference path="./d/externals.d.ts" />
var extend = require('extend');
var escapeHtml = require('escape-html');
var builtins = require('./builtins');
function autolink(text, arg1, arg2) {
    var transforms, options;
    if (Array.isArray(arg1)) {
        transforms = arg1;
        options = arg2;
    }
    else {
        transforms = null;
        options = arg1;
    }
    options = extend(true, {}, defaultOptions, options);
    if (transforms == null) {
        //default
        transforms = ["url"];
    }
    //built-in transforms
    for (var i = 0, l = transforms.length; i < l; i++) {
        if ("string" === typeof transforms[i]) {
            transforms[i] = builtins[transforms[i]];
        }
    }
    var matchings = [];
    //まず全てをmatchする
    for (var i = 0, l = transforms.length; i < l; i++) {
        var t = transforms[i], p = t.pattern(options);
        if (p.global !== true) {
            throw new Error("Pattenrs must have its global flag set");
        }
        var o = p.exec(text);
        if (o) {
            //matchした
            var j = 0;
            for (; j < matchings.length; j++) {
                if (o.index < matchings[j].position) {
                    break;
                }
            }
            matchings.splice(j, 0, {
                transform: t,
                pattern: p,
                result: o,
                position: o.index
            });
        }
    }
    var result = "", idx = 0;
    //matchをreplaceして解消していく
    while (matchings.length > 0) {
        var m = matchings[0], tr = (_a = m.transform).transform.apply(_a, [options].concat(m.result));
        if (m.result[0] === "") {
            throw new Error("Matching with the empty string is not allowed");
        }
        //HTMLを生成
        var html = generateA(tr, m.result[0]);
        //前の部分とマッチ部分を入れる
        result += escapeHtml(text.slice(idx, m.position)) + html;
        idx = m.position + m.result[0].length;
        //開始位置を通り過ぎたやつはもう使えないのでマッチし直す
        for (var i = 0; i < matchings.length; i++) {
            var m2 = matchings[i];
            if (m2.position < idx) {
                var o = void 0;
                do {
                    o = m2.pattern.exec(text);
                } while (o != null && o.index < idx);
                if (o != null) {
                    //idxの先にマッチがあった（まだ使えるかも）
                    var j = 0;
                    for (; j < matchings.length; j++) {
                        if (matchings[j].position > o.index) {
                            break;
                        }
                    }
                    matchings.splice(j, 0, {
                        transform: m2.transform,
                        pattern: m2.pattern,
                        result: o,
                        position: o.index
                    });
                }
                //自身は消す
                matchings.splice(i, 1);
                i--;
            }
            else {
                break;
            }
        }
    }
    //remaining text
    if (idx < text.length) {
        result += escapeHtml(text.slice(idx));
    }
    return result;
    var _a;
}
exports.autolink = autolink;
var defaultOptions = {
    url: {
        requireSchemes: true,
        schemes: ["http", "https"],
        attributes: {}
    }
};
function generateA(obj, defaultText) {
    var result = "<a";
    for (var key in obj) {
        //属性
        if (obj[key] != null) {
            result += " " + escapeHtml(key) + "='" + escapeHtml(obj[key]) + "'";
        }
    }
    result += ">" + escapeHtml(obj.text || defaultText) + "</a>";
    return result;
}
